#include "stdafx.h"
#include <objbase.h>
#include <stdio.h>
#include <tchar.h>
#include <atlbase.h>
#include <stdio.h>
#include <time.h>
#include <io.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include "papertoolscom.h"
#include <string>
using namespace std;

string GetParentFolder()
{
	char out_path[1024] = {0};
	char *p;
	GetModuleFileName(NULL, out_path, sizeof(out_path));
	p = strrchr(out_path,'\\');
	p[0] = 0;
	p = strrchr(out_path,'\\');
	p[0] = 0;
	return out_path;
}

std::string intToString(int i)
{
	CHAR szTemp[1024] = {0};
	sprintf(szTemp, "%d", i);	
    return szTemp;
}

void main()
{
	::CoInitialize(NULL);

	_PaperToolsCom VeryPDFCom;
	try
	{
		VeryPDFCom.CreateDispatch("VeryPDF.PaperToolsCom");
	}
	catch(COleDispatchException* pEx)
	{
		printf("Something is wrong...\n");
		return;
	}

	CString strReturn = "";
	int nFileIndex = 0;
	VeryPDFCom.EnableDebugLog(true);

	string strFolder = GetParentFolder();
	
    string strInFile = strFolder + "\\sample\\test_table_ocr.tif";
    string strOutFile = strFolder + "\\sample\\output\\_output_" + intToString(nFileIndex) + ".png";
    string strCmd = "-$ XXXXXXXXXXXXXXXXXX -removelongline 0 -boxobjects \"" + strInFile + "\" \"" + strOutFile + "\"";
	printf("%s\n", strCmd.c_str());
    strReturn = strReturn + VeryPDFCom.PaperTools(strCmd.c_str());
    nFileIndex = nFileIndex + 1;
	
    strInFile = strFolder + "\\sample\\test_black_border1.jpg";
    strOutFile = strFolder + "\\sample\\output\\_output_" + intToString(nFileIndex) + ".tif";
    strCmd = "-$ XXXXXXXXXXXXXXXXXX -removelongline 0 \"" + strInFile + "\" \"" + strOutFile + "\"";
	printf("%s\n", strCmd.c_str());
    strReturn = strReturn + VeryPDFCom.PaperTools(strCmd.c_str());
    nFileIndex = nFileIndex + 1;
	
    strInFile = strFolder + "\\sample\\test_despeckle.tif";
    strOutFile = strFolder + "\\sample\\output\\_output_" + intToString(nFileIndex) + ".tif";
    strCmd = "-$ XXXXXXXXXXXXXXXXXX -removeshortline 5 \"" + strInFile + "\" \"" + strOutFile + "\"";
	printf("%s\n", strCmd.c_str());
    strReturn = strReturn + VeryPDFCom.PaperTools(strCmd.c_str());
    nFileIndex = nFileIndex + 1;
	
    strInFile = strFolder + "\\sample\\test_despeckle.tif";
    strOutFile = strFolder + "\\sample\\output\\_output_" + intToString(nFileIndex) + ".tif";
    strCmd = "-$ XXXXXXXXXXXXXXXXXX -removeshortline 3 -removelongline 0 \"" + strInFile + "\" \"" + strOutFile + "\"";
	printf("%s\n", strCmd.c_str());
    strReturn = strReturn + VeryPDFCom.PaperTools(strCmd.c_str());
    nFileIndex = nFileIndex + 1;
	
    strInFile = strFolder + "\\sample\\test_line.png";
    strOutFile = strFolder + "\\sample\\output\\_output_" + intToString(nFileIndex) + ".tif";
    strCmd = "-$ XXXXXXXXXXXXXXXXXX -removelongline 200 \"" + strInFile + "\" \"" + strOutFile + "\"";
	printf("%s\n", strCmd.c_str());
    strReturn = strReturn + VeryPDFCom.PaperTools(strCmd.c_str());
    nFileIndex = nFileIndex + 1;
	
    strInFile = strFolder + "\\sample\\test_table_ocr.tif";
    strOutFile = strFolder + "\\sample\\output\\_output_" + intToString(nFileIndex) + ".tif";
    strCmd = "-$ XXXXXXXXXXXXXXXXXX -removelongline 100 \"" + strInFile + "\" \"" + strOutFile + "\"";
	printf("%s\n", strCmd.c_str());
    strReturn = strReturn + VeryPDFCom.PaperTools(strCmd.c_str());
    nFileIndex = nFileIndex + 1;
	
    strInFile = strFolder + "\\sample\\test_skew.tif";
    strOutFile = strFolder + "\\sample\\output\\_output_" + intToString(nFileIndex) + ".tif";
    strCmd = "-$ XXXXXXXXXXXXXXXXXX -removelongline 0 \"" + strInFile + "\" \"" + strOutFile + "\"";
	printf("%s\n", strCmd.c_str());
    strReturn = strReturn + VeryPDFCom.PaperTools(strCmd.c_str());
    nFileIndex = nFileIndex + 1;
	
    strInFile = strFolder + "\\sample\\test_negative.png";
    strOutFile = strFolder + "\\sample\\output\\_output_" + intToString(nFileIndex) + ".tif";
    strCmd = "-$ XXXXXXXXXXXXXXXXXX -deskew -skewrange 45 \"" + strInFile + "\" \"" + strOutFile + "\"";
	printf("%s\n", strCmd.c_str());
    strReturn = strReturn + VeryPDFCom.PaperTools(strCmd.c_str());
    nFileIndex = nFileIndex + 1;
	
    strInFile = strFolder + "\\sample\\test_negative.png";
    strOutFile = strFolder + "\\sample\\output\\_output_" + intToString(nFileIndex) + ".tif";
    strCmd = "-$ XXXXXXXXXXXXXXXXXX -deskew2 \"" + strInFile + "\" \"" + strOutFile + "\"";
	printf("%s\n", strCmd.c_str());
    strReturn = strReturn + VeryPDFCom.PaperTools(strCmd.c_str());
    nFileIndex = nFileIndex + 1;
	
    strInFile = strFolder + "\\sample\\test_despeckle.tif";
    strOutFile = strFolder + "\\sample\\output\\_output_" + intToString(nFileIndex) + ".tif";
    strCmd = "-$ XXXXXXXXXXXXXXXXXX -despeckle \"" + strInFile + "\" \"" + strOutFile + "\"";
	printf("%s\n", strCmd.c_str());
    strReturn = strReturn + VeryPDFCom.PaperTools(strCmd.c_str());
    nFileIndex = nFileIndex + 1;
	
    strInFile = strFolder + "\\sample\\test_despeckle.tif";
    strOutFile = strFolder + "\\sample\\output\\_output_" + intToString(nFileIndex) + ".tif";
    strCmd = "-$ XXXXXXXXXXXXXXXXXX -despeckle2 -specklesize 20 \"" + strInFile + "\" \"" + strOutFile + "\"";
	printf("%s\n", strCmd.c_str());
    strReturn = strReturn + VeryPDFCom.PaperTools(strCmd.c_str());
    nFileIndex = nFileIndex + 1;
	
    strInFile = strFolder + "\\sample\\test_despeckle.tif";
    strOutFile = strFolder + "\\sample\\output\\_output_" + intToString(nFileIndex) + ".tif";
    strCmd = "-$ XXXXXXXXXXXXXXXXXX -removeborder -fuzz 50 \"" + strInFile + "\" \"" + strOutFile + "\"";
	printf("%s\n", strCmd.c_str());
    strReturn = strReturn + VeryPDFCom.PaperTools(strCmd.c_str());
    nFileIndex = nFileIndex + 1;
	
    strInFile = strFolder + "\\sample\\test_black_border1.jpg";
    strOutFile = strFolder + "\\sample\\output\\_output_" + intToString(nFileIndex) + ".tif";
    strCmd = "-$ XXXXXXXXXXXXXXXXXX -removeborder -fuzz 80 \"" + strInFile + "\" \"" + strOutFile + "\"";
	printf("%s\n", strCmd.c_str());
    strReturn = strReturn + VeryPDFCom.PaperTools(strCmd.c_str());
    nFileIndex = nFileIndex + 1;
	
    strInFile = strFolder + "\\sample\\test_black_border1.jpg";
    strOutFile = strFolder + "\\sample\\output\\_output_" + intToString(nFileIndex) + ".tif";
    strCmd = "-$ XXXXXXXXXXXXXXXXXX -trimmargin -fuzz 80 \"" + strInFile + "\" \"" + strOutFile + "\"";
	printf("%s\n", strCmd.c_str());
    strReturn = strReturn + VeryPDFCom.PaperTools(strCmd.c_str());
    nFileIndex = nFileIndex + 1;
	
    strInFile = strFolder + "\\sample\\test_black_border1.jpg";
    strOutFile = strFolder + "\\sample\\output\\_output_" + intToString(nFileIndex) + ".tif";
    strCmd = "-$ XXXXXXXXXXXXXXXXXX -trimmargin \"" + strInFile + "\" \"" + strOutFile + "\"";
	printf("%s\n", strCmd.c_str());
    strReturn = strReturn + VeryPDFCom.PaperTools(strCmd.c_str());
    nFileIndex = nFileIndex + 1;
	
    strInFile = strFolder + "\\sample\\test_table_ocr.tif";
    strOutFile = strFolder + "\\sample\\output\\_output_" + intToString(nFileIndex) + ".tif";
    strCmd = "-$ XXXXXXXXXXXXXXXXXX -trimmargin -trimcolor FFFFFF -fuzz 100 \"" + strInFile + "\" \"" + strOutFile + "\"";
	printf("%s\n", strCmd.c_str());
    strReturn = strReturn + VeryPDFCom.PaperTools(strCmd.c_str());
    nFileIndex = nFileIndex + 1;
	
    strInFile = strFolder + "\\sample\\test_table_ocr.tif";
    strOutFile = strFolder + "\\sample\\output\\_output_" + intToString(nFileIndex) + ".tif";
    strCmd = "-$ XXXXXXXXXXXXXXXXXX -ocr -boxpic \"" + strInFile + "\" \"" + strOutFile + "\"";
	printf("%s\n", strCmd.c_str());
    strReturn = strReturn + VeryPDFCom.PaperTools(strCmd.c_str());
    nFileIndex = nFileIndex + 1;
	
    strInFile = strFolder + "\\sample\\test_table_ocr.tif";
    strOutFile = strFolder + "\\sample\\output\\_output_" + intToString(nFileIndex) + ".tif";
    strCmd = "-$ XXXXXXXXXXXXXXXXXX -layout \"" + strInFile + "\" \"" + strOutFile + "\"";
	printf("%s\n", strCmd.c_str());
    strReturn = strReturn + VeryPDFCom.PaperTools(strCmd.c_str());
    nFileIndex = nFileIndex + 1;

	printf("Message: %s\n", strReturn);
}